﻿
Ext.define('NexBook.controller.Captionbar',{
	extend:'Ext.app.Controller',
	requires:['NexBook.view.Captionbar','NexBook.store.PageImg'],
	
	config:{
		refs:{
			mainView: 'main_view',
			captionBar: 'captionbar_view',
			hideButton: 'main_view container button[name=hideBtn]',
			closeButton : 'captionbar_view button[name=closeBtn]',
			toolbarTogleBtn : 'captionbar_view button[name=toolbarTogle]',
			zoomHBtn : 'captionbar_view button[name=zoomHeight]',
			zoomWBtn : 'captionbar_view button[name=zoomWidth]',
			zoomOutBtn : 'captionbar_view button[name=zoomOut]',
			zoomInBtn : 'captionbar_view button[name=zoomIn]',
			zoomViewBtn : 'captionbar_view button[name=view]',
			zoomView2Btn : 'captionbar_view button[name=view2]',
			zoomView4Btn : 'captionbar_view button[name=view4]',
			pageStore: 'page_img_store'
			
		},
		control:{
			
			'closeButton':{
				tap:'closeDoc'
			},
			'toolbarTogleBtn':{
				tap:'tapEventFun'
			},
			'zoomHBtn':{
				tap:'tapEventFun'
			},
			'zoomWBtn':{
				tap:'tapEventFun'
			},
			'zoomOutBtn':{
				tap:'tapEventFun'
			},
			'zoomInBtn':{
				tap:'tapEventFun'
			},
			'zoomViewBtn':{
				tap:'tapEventFun'
			},
			'zoomView2Btn':{
				tap:'tapEventFun'
			},
			'zoomView4Btn':{
				tap:'tapEventFun'
			}
		}
	},
	
	tapEventFun:function(el,event){
		
		//console.log(el,event);
		var btnName = el.config.name;
		switch(el.config.name){
			case "zoomWidth":
				this.pageResizing('widthfull');
				break;
			case "zoomHeight":
				this.pageResizing('heightfull');
				break;
			case "view":
				this.pageViewReload('view');
				break;
			case "view2":
				this.pageViewReload('view2');
				break;
			case "view4":
				this.pageViewReload('view4');
				break;
			case "zoomIn":
				this.tapUnPressed(el);
				this.pageZoom('in');
				break;
			case "zoomOut":
				this.tapUnPressed(el);
				this.pageZoom('out');
				break;
			case "toolbarTogle":
				this.captionbarHide();
				break;
			default:console.log('btn_error');
		}
	},
	
	tapUnPressed:function(btn){
		btn.getParent().setPressedButtons();
	},
	
	captionbarHide:function(){
		
		//toggle - 
		var hideBar = Ext.create('Ext.Container',{
			docked:"top",
			layout:{
				type:"hbox",
				pack:"center",
				align:"middle"
			},
			
			width:35,
			style:'position:absolute; z-index:1010; left:4px; top:8px;',
			items:[{
		        		xtype:"button",
		        		ui:'action',
		        		//text: 'hide',
		        		iconCls: 'arrow_down',
		        		iconMask: true,
		        		padding:3,
		        		name:'hideBtn',
		        		cls:'toolbarTogle-btn cursorPointer',
		        		handler:this.captionbarShow
		        	}]
	        	
	     });
	     
	     this.getMainView().add(hideBar); 
	     this.getCaptionBar().setHidden(true);
	   
	},
	
	captionbarShow:function(btn,e){
		btn.getParent().getParent().getComponent(0).setHidden(false);
		btn.getParent().remove(this);
		
	},
	
	pageResizing:function(type){
		var windowWidth = $('div.x-body').width();
        var windowHeight = $('div.x-body').height();
        var getPageData = Ext.getStore('PageImgStore').getData();
		var totalItem = Ext.getStore('PageImgStore').getData().length;
		
		
		this.getMainView().removeAll();
		
		this.getZoomViewBtn().getParent().setPressedButtons(0); //view버튼 presse 첫번재
		
        if(type=='widthfull'){
        	//$('div.temp-page img').attr({'width':windowWidth});
			//$('div.temp-page img').removeAttr('height');
        	var template = new Ext.XTemplate(
	        	"<div id='temp-page-{id}' class='temp-page'>",
	        	"<img width="+ windowWidth +" src='../{page}'></img>",
	        	"</div>"
	        );
        }else if(type=='heightfull'){
        	//$('div.temp-page img').attr({'height':windowHeight});
			//$('div.temp-page img').removeAttr('width');
        	var template = new Ext.XTemplate(
	        	"<div id='temp-page-{id}' class='temp-page'>",
	        	"<img height="+ windowHeight +" src='../{page}'></img>",
	        	"</div>"
	        );
        }
        
        for(var i=0; i<totalItem;i++){
        	var page = Ext.create('Ext.Panel',{
        		id:'panel-page-'+i,
        		html:'book_'+i,
        		width:windowWidth,
        		cls:'panel-page',
        		tpl:template
        	});
        	//받아온 model data 연결
        	page.setData(getPageData.items[i].data);
    		this.getMainView().add(page);
    	};
    	
    	
	},
	
	pageViewReload:function(viewnum){
		var totalItem = Ext.getStore('PageImgStore').getData().length;
		var getPageData = Ext.getStore('PageImgStore').getData();
		var panelCls;
		
		var orientData = window.orientation;
		
		var windowWidth = $('div.x-body').width();
        var windowHeight = $('div.x-body').height();
		var imgWidth = document.getElementById('temp-page-1').firstChild.clientWidth;
						
		this.getMainView().removeAll();
		
        if(viewnum=='view'){
        	var template = new Ext.XTemplate(
	        	"<div id='temp-page-{id}' class='temp-page'>",
	        	 '<img height='+ windowHeight +' src="../{page}"></img>',
	        	"</div>"
	        );
        
        	for(var i=0; i<totalItem;i++){
	        	
	        	var page = Ext.create('Ext.Panel',{
	        		id:'panel-page-'+i,
	        		html:'book_'+i,
	        		width:windowWidth,
	        		cls:'panel-page',
	        		tpl:template
	        	});
	        	//받아온 model data 연결
	        	page.setData(getPageData.items[i].data);
	    		this.getMainView().add(page);
	    	};
	    	
        }else if(viewnum=='view2'){
        	
       
    		if(windowWidth<windowHeight){ //세로
				var template = new Ext.XTemplate(
		        	"<div id='temp-page-{id}' class='temp-page'>",
		        	 '<img width='+ windowWidth/2 +' src="../{page}"></img>',
		        	"</div>"
		        );
			}else if(windowWidth>windowHeight){ //가로
				var template = new Ext.XTemplate(
		        	"<div id='temp-page-{id}' class='temp-page'>",
		        	 '<img height='+ windowHeight +' src="../{page}"></img>',
		        	"</div>"
		        );
			}
        	
	        var pageAll = Ext.create('Ext.Panel',{
        		//width:imgWidth*2,
        		cls:'panel-all-pages'
        	});
	        	
        	//console.log('imgWidth:',imgWidth);
    		for(var i=0; i<totalItem;i=i+2){
    			
				var pages = Ext.create('Ext.Panel',{
	        		//width:imgWidth*2,
	        		cls:'panel-two-pages'
	        	});
	  
	        	var page = Ext.create('Ext.Panel',{
	        		id:'panel-page-'+i,
	        		html:'book_'+i,
	        		//width:imgWidth,
	        		cls:'panel-tow-page-left',
	        		tpl:template
	        	});
	        	//받아온 model data 연결
	        	page.setData(getPageData.items[i].data);
	    		pages.add(page);
	    		
	        	var page2 = Ext.create('Ext.Panel',{
	        		id:'panel-page-'+(i+1),
	        		html:'book_'+(i+1),
	        		//width:imgWidth,
	        		cls:'panel-tow-page-right',
	        		tpl:template
	        	});
	        	//받아온 model data 연결
	        	try{
	        		page2.setData(getPageData.items[i+1].data);
		    		pages.add(page2);
		    		
		    		pageAll.add(pages);
	        	}catch(e){
	        		//console.log("page not:",i+1)
	        	}
	        	
        	}
	        
	    	for(var i=0; i<=pageAll.items.length;i++){
	    		this.getMainView().add(pageAll);
	    	};
	    	
	        
        }else if(viewnum=='view4'){
        	
    		var template = new Ext.XTemplate(
	        	"<div id='temp-page-{id}' class='temp-page'>",
	        	 '<img height='+ windowHeight/2 +' src="../{page}"></img>',
	        	"</div>"
	        );
	        
	        var pageAll = Ext.create('Ext.Panel',{
        		//width:imgWidth,
        		cls:'panel-all-pages'
        	});
	        	
        	//console.log('imgWidth:',imgWidth);
    		for(var i=0; i<totalItem;i=i+2){
    			
				var pages = Ext.create('Ext.Panel',{
	        		//width:imgWidth,
	        		cls:'panel-two-pages'
	        	});
	  
	        	var page = Ext.create('Ext.Panel',{
	        		id:'panel-page-'+i,
	        		html:'book_'+i,
	        		//width:imgWidth/2,
	        		cls:'panel-tow-page-left',
	        		tpl:template
	        	});
	        	//받아온 model data 연결
	        	page.setData(getPageData.items[i].data);
	    		pages.add(page);
	    		
	        	var page2 = Ext.create('Ext.Panel',{
	        		id:'panel-page-'+(i+1),
	        		html:'book_'+(i+1),
	        		//width:imgWidth/2,
	        		cls:'panel-tow-page-right',
	        		tpl:template
	        	});
	        	//받아온 model data 연결
	        	try{
	        		page2.setData(getPageData.items[i+1].data);
		    		pages.add(page2);
		    		
		    		pageAll.add(pages);
	        	}catch(e){
	        		//console.log("page not:",i+1)
	        	}
        	}
	        
	    	for(var i=0; i<=pageAll.items.length;i++){
	    		this.getMainView().add(pageAll);
	    	};
	    	
        }
        
        
	},
	
	pageZoom:function(type){
		var zoomType = type;
		
		if(zoomType=='in'){
			$('div.temp-page').contents().effect('scale', {percent:120, scale:'box'},100);
		}else if(zoomType=='out'){
			$('div.temp-page').contents().effect('scale', {percent:80, scale:'box'},100);
		}
	},
	
	closeDoc:function(){
		$(parent.viewport)[0].style.removeProperty('display');
		$(parent.toolbarShowBtn)[0].style.removeProperty('display');
		$(parent.viewport).css({'opacity':1});
		$(parent.toolbarShowBtn).css({'opacity':1});
		
		try{
			$(parent.toolbarThumbnail)[0].style.removeProperty('display');
			$(parent.toolbarThumbnail).css({'opacity':1});
			$(parent.toolbarControl)[0].style.removeProperty('display');
			$(parent.toolbarControl).css({'opacity':1});
		}catch(e){
			;
		}
		$(parent.docuview).remove();
		
	}
   
});

//EbookApp.controllers.toolBarController = Ext.ControllerManager.get('ToolBarController');
