var mainView;
var scrollValue = 0;
Ext.define('NexBook.controller.Main', {
    extend: 'Ext.app.Controller',
    alias: 'controller.main_control',
    requires: [
        'NexBook.view.Toolbar',
        'NexBook.view.Captionbar'
    ],
  
    init:function(){
	   
    },
   
    config: {
        refs: {
            mainView: 'main_view',
            mainScroller:'main_view scroll',
            totalPageLabel: 'toolbar_view label[name=totalNum]'
        },
        control: {
            "panel": {
                initPage: 'onPanelInitialize',
                resizePage: 'onPanelResize'
                
            }
            
        }
    },
	
    //PageImg.js 에서 init dispach시 발생 - 초기화
    onPanelInitialize: function(component, options) {
    	this.getMainView().removeAll();
    	
    	
    	
        /* toolbar 추가 */
        var toolbar = Ext.create('NexBook.view.Toolbar',{
        	//toolbar에 추가할 메뉴 및 옵션 변경/추가
        });
       // this.getMainView().add(toolbar);
         
        /* captionbar 추가 */
       
        	//phone
        //alert(Ext.os.name+"_"+Ext.os.deviceType);
        if(Ext.os.deviceType=='Desktop'||Ext.os.deviceType=='Tablet'){
        	//pc && tablit
        	 var captionbar = Ext.create('NexBook.view.Captionbar',{
	        	//captionbar에 추가할 메뉴 및 옵션 변경/추가
	        	
	        });
        }else if(Ext.os.deviceType=='Phone'){
        	//Phone
        	 var captionbar = Ext.create('NexBook.view.phone.Captionbar',{
	        	//captionbar에 추가할 메뉴 및 옵션 변경/추가
	        	
	        });
        }
       
        this.getMainView().add(captionbar);
        
        this.onPanelResize(component);
		
    },
    
    onPanelResize:function(component){
    	/* 데이터 연결 */
    	var data = component;
    	var totalPage = component[0].total;
    	var pageData = component[1].pageData;
    	var pageUrl = pageData;
    	
    	//scroller 추가
        this.getMainView().setScrollable('vertical');
        
        /* 템플릿 생성  */
        var windowWidth = $('div.x-body').width();
        var windowHeight = $('div.x-body').height();
        //var windowWidth = '100%';
        //var windowHeight = '100%';
        
        var template = new Ext.XTemplate(
        	"<div id='temp-page-{id}' class='temp-page'>",
        	"<img height="+ windowHeight +" src='../{page}'></img>", //basic
        	//"<img width='100%' height='100%' src='../../../{url}'></img>", //꽉찬 화면 - img 로딩이 제대로 안됨
        	"</div>"
        );
        
        for(var i=0; i<totalPage;i++){
        	var page = Ext.create('Ext.Panel',{
        		id:'panel-page-'+i,
        		html:'book_'+i,
        		width:windowWidth,
        		cls:'panel-page',
        		tpl:template
        	});
        	//받아온 model data 연결
        	page.setData(pageUrl.items[i].data);
        	
    		this.getMainView().add(page);
    	};
      
    	
    	/* total pageNum set  */
    	//this.getTotalPageLabel().setHtml("/ "+totalPage);
    	
    	
    	/* mouse wheel event add */
    	mainView = this.getMainView();
    	    	
    	$('body').bind('mousewheel.docEventGroup',function(e){
    		
    		var delta = getWheelDelta(e.originalEvent),
				dt = e.timeStamp - (this.mouseWheelStartTime || 0);
			if (dt < this.mouseWheelSpeed) {
				return;
			}
			this.mouseWheelStartTime = e.timeStamp;
			
			if (delta < 0){
				scrollValue = scrollValue+50;
			}
			else if (delta > 0){
				scrollValue = scrollValue-50;
			}
			//console.log('scrollValue:',scrollValue);
			mainView.getScrollable().getScroller().scrollTo(0,scrollValue,true);
			
			function getWheelDelta(event){
				
				var delta = 0;
				
				if (!isNothing(event.wheelDelta)){
					delta = event.wheelDelta / 120;
				}
				else if (!isNothing(event.detail)){
					delta = -event.detail / 3;
				}
				return delta;
						
			}
			function isNothing(obj) {
				if (typeof obj === "undefined" || obj === null) {
					return true;
				}	
				return false;
			}
    	})
    	
    	// scroll이 끝났을 때 y값 갱신 이벤트 등록
    	mainView.getScrollable().getScroller().on('scrollend', function(scroll, x, y) {
			scrollValue = y;
		})
		
		this.onPanelAddResizeEvent(data);
    	
    	/* loading box remove */
    	$(parent.docuviewLoading).remove();
    	console.log("___document view Load Complete___");
    
    },
    
    onPanelAddResizeEvent: function(component) {
    	this.getMainView().getParent().on('resize',function(e){
    		//alert('resize!');
    		//setTimeout(function(){
    		mainView.removeAll();
    		
    		/*
    		if(Ext.os.is('Android')){
    			var setHeight = (parseInt($(parent.docuview_frame).css('height'))-43)
    			$('div.x-body').height(setHeight);
    			Ext.getBody().setHeight(setHeight);
    			//$('body').height(600)
    			//mainView.getPanret().remove()
    		
	    		var windowWidth = $('div.x-body').width();
	    		var windowHeight = $('div.x-body').height();
	    		
	    		//alert('x-body:'+windowWidth+" "+windowHeight);
	    		//mainView.resetFloating();
	    		
	    		//alert('body:'+Ext.getBody().getHeight()+" html:"+Ext.getBody().getParent().getHeight()+" docview:"+$(parent.docuview).height());
	    		//alert($('.x-scroll-view').height()+" "+$('.x-scroll-bar-grid-wrapper').height()+" "+$('.x-scroll-container').height())
	    		//alert($('.x-scroll-scroller').height()+" "+$('.panel-page').height()+" "+$('.panel-page div').height()+" "+$('.panel-page div div').height())
    		}
    		*/
			Ext.defer(function(){
				mainView.fireEvent('resizePage',component);
			});
			
        	//$('div.x-body').height((parseInt($(parent.docuview).css('height'))-43));
        	
        	
        	//$('div.temp-page').height((parseInt($(parent.docuview).css('height'))-43))
        	
        	//console.log($('div.x-body').height());
        	//alert('x-body:'+windowWidth+" "+windowHeight);
        	//alert('temp-page-1:'+$('div.temp-page').height())
        	//alert('docuview:'+$(parent.docuview).css('height'))
        	//alert($(parent.docuview).contents().height()+" "+$('.temp-page').eq(0).contents().height())
    		//},600)
    		
    	},this,{
    		single: true,
    		delay :500
    	});
    }
});