﻿var tapTimer = true;

Ext.define('NexBook.controller.Toolbar',{
	extend:'Ext.app.Controller',
	requires:['NexBook.view.Toolbar'],
	
	config:{
		refs:{
			mainView: 'main_view',
			prevButton: 'toolbar_view button[name=prevBtn]',
			nextButton: 'toolbar_view button[name=nextBtn]',
			closeButton : 'toolbar_view button[name=closeBtn]',
			currentPageInput: 'toolbar_view numberfield[name=currentNum]',
			totalPageLabel: 'toolbar_view label[name=totalNum]',
			pageStore: 'page_img_store'
		},
		control:{
			'prevButton':{
				release:'pageMoveSet'
			},
			'nextButton':{
				release:'pageMoveSet'
			},
			'mainView':{
				activeitemchange:'slideMoveSet'
			},
			'currentPageInput':{
				change:'currentPageInputChange'
			}
		}
	},
	
	
	currentPageInputChange:function(field,nNum,oNum){
		//console.log('nNum:',nNum);
		var newNum = parseInt(nNum);
		var oldNum = parseInt(oNum);
		this.getMainView().animateActiveItem(newNum-1,'slide')
		
	},
	
	pageMoveSet:function(el,e){
		if(tapTimer){
			//console.log("page이동:",el.getText());
			//console.log("event:",e);
			var moveText = el.getText();
			
			if(moveText=="next"){
				this.getMainView().next();
				
			}else if(moveText=="prev"){
				this.getMainView().previous();
				
			}else{
			   console.log("error");
			}
			
			tapTimer = false;
			setTimeout(function(){
				tapTimer = true;
			},500)
		}
		
	},
	
	
	slideMoveSet:function(el,value){
		//console.log(value.getId());
		var number = value.getId().split('-')[2];
		//console.log('number:',number);
		this.toolbarReset(parseInt(number)+1);
	},
	
	
	toolbarReset:function(setNumber){
		
			var totalPageNum =this.getTotalPageLabel().getHtml();
			totalPageNum = totalPageNum.substr(2,totalPageNum.length);
			
			//console.log("page:",setNumber+"/"+totalPageNum);
			
			if(setNumber<1||setNumber>totalPageNum){
				//console.log("more not page");
			}else{
				this.getCurrentPageInput().setValue(setNumber);
			}
			
		
	}
   
});

//EbookApp.controllers.toolBarController = Ext.ControllerManager.get('ToolBarController');
