Ext.define('NexBook.store.PageImg', {
    extend: 'Ext.data.Store',
    alias: 'store.page_img_store',
    requires: [
        'NexBook.model.PageImg'
    ],

    config: {
    	refs: {
            mainView: 'main_view'
        },
        
    	autoLoad:true,
        model: 'NexBook.model.PageImg',
        storeId: 'PageImgStore',
        proxy: {
            type: 'ajax',
            url: '../assets/data/pages.xml',
            //url: 'assets/data/pages.json',
            reader: {
                type: 'xml',
                record:'page'
            }
        },
        listeners:({
        	//store에 page 데이터 로드 후 
        	load:function(){
        		//console.log('___store load___');	
        		//console.log("total page Num:",this.getData().length);	
        		//console.log(this.getData().length);	
        		var totalPage = this.getData().length;
        		var pageData  = this.getData();
        		
        		var mainView = Ext.create('NexBook.view.Main', {fullscreen: true});
        		
        		var data = [{'total':totalPage},{'pageData':pageData}];
        		Ext.defer(function(){
					mainView.fireEvent('initPage',data);
				});
        	}
        })
    }    
   	
});