THIS = this;

$(document).ready(function(){
    
    /* element */
    THIS.$preview = $('#preview');
    THIS.$printSelect = $('#printSelect');
    THIS.$printRadios = $('input.page-selector');
    THIS.$pageSelectFirst = $('#num_start');
    THIS.$pageSelectLast = $('#num_end');
    THIS.$lockupCheck = $('#lockupBox');
    THIS.$printBtn = $('#printBtn');
    THIS.$cancleBtn = $('#cancleBtn');
    THIS.$closeBtn = $('#printCloseBtn');
    
    /* load page data */
    loadPageData();
    
    /* render page data */
    THIS.renderData =  null;
    THIS.imgWidth = null;
    THIS.imgHeight = null;
        
    initialize();
            
});

this.loadPageData = function(win){
    /* load page data */
    THIS.pageData = window.parent.ebookData;
    THIS.currentPages = window.parent.currentPage;
    THIS.totalPageNum = THIS.pageData.totalPages;
    THIS.allPagesData = THIS.pageData.pageObjs;
    THIS.proxy = window.parent.proxy;
    THIS.ebookWidth = window.parent.ebookWidth;
    THIS.ebookHeight = window.parent.ebookHeight;
    THIS.originWidth = window.parent.pageOriginWidth;
    THIS.originHeight = Math.round(((THIS.ebookHeight*(THIS.originWidth))/(THIS.ebookWidth/2)));
    THIS.URL = window.parent.nexbookUrl;
    
}

this.initialize = function()
{
        //console.log(THIS.proxy.getPageSources());
        
        var display = THIS.pageData.display;
        var someWidth = display == "single" ? THIS.pageData.opts.width : THIS.pageData.opts.width/2

        /* 인쇄설정 select 초기화 */
        if(display=='double'){
            THIS.$printSelect.removeAttr('disabled');
            
        }else if(display=='single'){
            THIS.$printSelect.attr({'disabled':'disabled'});
        }
        
        /* 이미지 사이즈 로드 */
        THIS.imgWidth = 740; //가로고정 (740 / 1046) A4비율
        THIS.imgHeight = Math.round(imgWidth*pageData.opts.height/someWidth); //가로 값에 따른 세로 비율로 값 계산
        
        
        /* 인쇄 범위 선택 페이지 영역 초기화 */
        THIS.$pageSelectFirst.attr({'min':1,'max':totalPageNum});
        THIS.$pageSelectLast.attr({'min':1,'max':totalPageNum});
        
        THIS.$pageSelectFirst.attr({'disabled':'disabled'});
        THIS.$pageSelectLast.attr({'disabled':'disabled'});
        
        $('#printView').css({'width':'1024'})
        THIS.$preview.css({'width':THIS.imgWidth+15,'height':parseInt(windowHeight())-150});
        
        /* 미리보기 영역 데이터 로딩 */
        THIS.renderData =  THIS.currentPages;
        render(display);
        
        /* event handler */
       //key bind        
        $(document).unbind();
        $(document).bind('keydown',function(e){
            
            if(e.keyCode == 27){
                printCancle();
            }else if(e.keyCode == 13){
                printStart();
            }
        })
        
        /* event handler */
        $printBtn.unbind();
        $printBtn.bind('click',printStart);
        
        $cancleBtn.unbind();
        $cancleBtn.bind('click',printCancle);
        
        $closeBtn.unbind();
        $closeBtn.bind('click',printCancle);
        
        $printSelect.unbind();
        $printSelect.bind('change',function(e){
            //console.log('----------selector change----------')
            render(THIS.pageData.display);
        })
        
        $lockupCheck.unbind();
        $lockupCheck.bind('click',function(e){
            $(this).attr('checked')
            if($(this).attr('checked')=='checked'){
                THIS.imgHeight = THIS.imgWidth*297/210; //a4비율
                //console.log('a4:',THIS.imgHeight)
            }else{
                THIS.imgHeight = Math.round(imgWidth*pageData.opts.height/someWidth); //가로 값에 따른 세로 비율로 값 계산
            }
            render(THIS.pageData.display);
        });
        
        $printRadios.unbind();
        $printRadios.bind('click',function(e){
            //console.log('----------checked----------');
            var checkName = $(e.target).val()
            //console.log('checkName:',checkName);
            
            switch(checkName)
            {
                case 'current': 
                    THIS.renderData =  THIS.currentPages; 
                    render(THIS.pageData.display);
                    THIS.$pageSelectFirst.attr({'disabled':'disabled'});
                    THIS.$pageSelectLast.attr({'disabled':'disabled'});
                    break;
                case 'ambit':    
                    THIS.$pageSelectFirst.removeAttr('disabled');
                    THIS.$pageSelectLast.removeAttr('disabled');
                    ambitSelector();
                    break;
                case 'all':     
                    THIS.renderData =  checkSelect(1,THIS.totalPageNum);
                    render(THIS.pageData.display);
                    THIS.$pageSelectFirst.attr({'disabled':'disabled'});
                    THIS.$pageSelectLast.attr({'disabled':'disabled'});
                    break;
                default: 
                    console.log('checkbox x');
            }
            
            
        })
}

this.render = function(type){
    
    THIS.$preview.contents().remove();

    /* 인쇄설정 데이터 */
    var printViewType = $("#printSelect > option:selected").val();
    
    /* view page load */
    var viewPages = THIS.renderData;
    //console.log(viewPages[0]);
    
    /* form create */
    var allForm = $("<div/>");
    allForm.addClass('allForm');
    allForm.attr({'id':'printDiv'});
    
    /* 변수값 설정 */
    var plusNumber = type=='single' ? 1 : 2;
    var startI = viewPages[0]%2==0 ? 0 : 1;
    var inum = parseInt(viewPages[0]);
    var rowsAddUse = (viewPages.length%2==0)?true:false;
    var forLength = (startI==1&&rowsAddUse==true)? viewPages[viewPages.length-1]+1 : viewPages[viewPages.length-1];
    //var forLength = viewPages[viewPages.length-1];
    //console.log('display type(1=single, 2=double):'+plusNumber," startI:"+startI);
    
    
    /******************/
    
    for(var i=inum;i<=forLength;i=i+plusNumber){
        //console.log('inum:'+inum,'totalNum:'+forLength,'i:'+i)
        //console.log('viewpages:'+viewPages[viewPages.indexOf(i)])
        //console.log('viewpages:'+viewPages[viewPages.indexOf(i+1)])
        var rowForm = $("<div/>");
        rowForm.addClass('rowForm');
        
        var rowsAdd = (startI==1&&rowsAddUse==true)?true:false;
        
        if(type=='single'){
            
            var $onePageData =  $("<div/>"); 
            try{
            
                //console.log('생성 one:'+(i)+'page');
                if(i<1){
                    ;
                }else{
                    //console.log('생성one Url:'+THIS.proxy.getPageSources()[i-1].url);
                    if(THIS.proxy.getPageSources()[i-1].url=='undefined'||THIS.proxy.getPageSources()[i-1].url==null){
                        //console.log('url null_'+(i)+'page');
                    }else{
                        var singleUrlString = THIS.proxy.getPageSources()[i-1].url;
                        $imgData = imageAddFuntion(singleUrlString);
                        contentsAdd($onePageData,$(THIS.proxy.getPage(i-1)),THIS.imgWidth,THIS.imgHeight,THIS.imgHeight/THIS.originHeight);
                    }
                    
                }
                    
                
            }catch(e){
                ;
            }
            
            $onePageData.append($imgData);
            $onePageData.addClass('print-one-page');
            
            rowForm.append($onePageData);
            rowForm.contents().css({'width':THIS.imgWidth,'height':THIS.imgHeight})
            
        }else if(type=='double'){
            var $twoPageLeftData =  $("<div/>"); 
            var $twoPageRightData = $("<div/>"); 
            
            var boxSizeWidth = null;
            var boxSizeHeight = null;
            if(printViewType!='양쪽'){
                boxSizeWidth = THIS.imgWidth;
                boxSizeHeight = THIS.imgHeight;
            }else{
                boxSizeWidth = THIS.imgWidth/2;
                boxSizeHeight = THIS.imgHeight/2;
            }
            
            if(startI==0){
            
                var $imgDataLeft;
                var $imgDataRight;
                
                //console.log('----------짝');
                
                try{
                    
                    //console.log('생성left:'+(i)+'page');
                    if((i)<1){
                        ;                       
                    }else{
                        //console.log('생성left Url:'+THIS.proxy.getPageSources()[i-1].url);
                        if(THIS.proxy.getPageSources()[i-1].url=='undefined'||THIS.proxy.getPageSources()[i-1].url==null){
                            //console.log('url null_'+(i)+'page');
                        }else{
                            var doubleLeftUrlString = THIS.proxy.getPageSources()[i-1].url;
                            $imgDataLeft = imageAddFuntion(doubleLeftUrlString);
                        }
                        
                        $twoPageLeftData.append($imgDataLeft);
                        contentsAdd($twoPageLeftData,$(THIS.proxy.getPage(i-1)),boxSizeWidth,boxSizeHeight,boxSizeHeight/THIS.originHeight);
                    }   
                
                    //console.log('생성right:'+(i+1)+'page');
                    if((i+1)<0||(i+1)>forLength){
                        ;                       
                    }else{
                        //console.log('생성right Url:'+THIS.proxy.getPageSources()[i].url);
                        if(THIS.proxy.getPageSources()[i].url=='undefined'||THIS.proxy.getPageSources()[i].url==null){
                            //console.log('url null_'+(i+1)+'page');
                        }else{
                            var doubleRightUrlString = THIS.proxy.getPageSources()[i].url;
                            $imgDataRight = imageAddFuntion(doubleRightUrlString);
                        }
                        
                        $twoPageRightData.append($imgDataRight);
                        contentsAdd($twoPageRightData,$(THIS.proxy.getPage(i)),boxSizeWidth,boxSizeHeight,boxSizeHeight/THIS.originHeight);
                    }
                    
                }catch(e){
                    ;
                }
                
                
            }else{
            
                var $imgDataLeft;
                var $imgDataRight;
                
                //console.log('----------홀');
                
                try{
                    
                    //console.log('생성left:'+(i-1)+' page');
                    if((i-1)<inum){
                        ;                       
                    }else{
                        //console.log('생성left Url:'+THIS.proxy.getPageSources()[i-2].url);
                        if(THIS.proxy.getPageSources()[i-2].url=='undefined'||THIS.proxy.getPageSources()[i-2].url==null){
                            console.log('url null_'+(i-1)+' page');
                        }else{
                            var doubleLeftUrlString = THIS.proxy.getPageSources()[i-2].url;
                            $imgDataLeft = imageAddFuntion(doubleLeftUrlString);
                        }
                        
                        $twoPageLeftData.append($imgDataLeft);
                        contentsAdd($twoPageLeftData,$(THIS.proxy.getPage(i-2)),boxSizeWidth,boxSizeHeight,boxSizeHeight/THIS.originHeight);
                    }
                    
                
                    //console.log('생성right:'+(i)+' page');
                    if(rowsAdd){
                        var lem = forLength-1;
                        //console.log('lem:'+lem)
                    }
                    if((i-1)<0||(i)>lem){
                        ;
                    }else{
                        //console.log('생성right Url:'+THIS.proxy.getPageSources()[i-1].url);
                        if(THIS.proxy.getPageSources()[i-1].url=='undefined'||THIS.proxy.getPageSources()[i-1].url==null){
                            console.log('url null_'+(i)+' page');
                        }else{
                            var doubleRightUrlString = THIS.proxy.getPageSources()[i-1].url;
                            $imgDataRight = imageAddFuntion(doubleRightUrlString);
                        }
                        
                        $twoPageRightData.append($imgDataRight);
                        contentsAdd($twoPageRightData,$(THIS.proxy.getPage(i-1)),boxSizeWidth,boxSizeHeight,boxSizeHeight/THIS.originHeight);
                    }
                    
                }catch(e){
                    ;
                }
            }
            
            
            if(printViewType=='왼쪽'){
                $twoPageLeftData.addClass('print-one-page');
                rowForm.append($twoPageLeftData);
                rowForm.contents().css({'width':THIS.imgWidth,'height':THIS.imgHeight})
                //console.log('left view:',rowForm)
                
            }else if(printViewType=='오른쪽'){
                $twoPageRightData.addClass('print-one-page');
                rowForm.append($twoPageRightData);
                rowForm.contents().css({'width':THIS.imgWidth,'height':THIS.imgHeight})
                //console.log('right view:',rowForm)
            }else{
                $twoPageLeftData.addClass('print-two-page-left');
                $twoPageRightData.addClass('print-two-page-right');
                
                rowForm.append($twoPageLeftData);
                rowForm.append($twoPageRightData);
                
                rowForm.contents().css({'width':THIS.imgWidth/2,'height':THIS.imgHeight/2});
                rowForm.css({'width':THIS.imgWidth+20,'height':THIS.imgHeight/2})
            }
                
        }
        
        /* 빈 페이지 추가 안하게 함 */
        if(printViewType!='양쪽'||type=='single'){
            if(rowForm.find('.nex-page-img').length==0){
                ;
            }else{
                allForm.append(rowForm);
            }
        }else{
            allForm.append(rowForm);
        }
        
    }
    //console.log('___allForm:',allForm);
    
    THIS.$preview.append(allForm);
    
}

this.checkSelect = function(first,last){
    var numArray = new Array();
    //console.log('THIS.totalPageNum:',THIS.totalPageNum);
    for(i=first;i<=last;i++){
        numArray.push(i);
        //console.log(i);
    }
    return numArray;
}

this.imageAddFuntion = function(urlData){
    
    var url = "../"+urlData;
    
    try{
        var imgEl = $("<img/>").addClass('nex-page-img').attr({'src':url}).css({'width':'100%','height':'100%'})
    }catch(e){
    
    }
    //console.log(imgEl);
    return imgEl;
}

this.contentsAdd = function(parent,xmlData,width,height,scale){
    
    var contents = xmlData.children();
    var returnComp = null;
    var contentsContainer = $("<div/>").addClass('nex-print-contents-container').css({'width':width,'height':height,'position':'absolute','overflow':'hidden'});
    //var scale = height / THIS.ebookHeight;
    parent.prepend(contentsContainer);
            
    for(var i=0; i<contents.length; i++){
       var compType = contents[i].nodeName;
       var returnComp = null;
       switch(compType){
           case "image":
                returnComp = THIS.imageCompCreate($(contents[i]),scale);
                contentsContainer.append(returnComp);
                break;   
           case "text":
                returnComp = THIS.textBoxCreate($(contents[i]),scale);
                contentsContainer.append(returnComp);
                break;
           case "linkButton":
                returnComp = THIS.linkBoxCreate($(contents[i]),scale);
                contentsContainer.append(returnComp);
                break;
           case "mp3player":
           case "mediaplayer":
                break;
       }
    }
}

this.ambitSelector = function(){
    /* render data 불러와서 표시 */
    var firstNumber = THIS.renderData[0];
    if(firstNumber==THIS.totalPageNum){
        var lastNumber = firstNumber;
    }else{
        var lastNumber = THIS.renderData[THIS.renderData.length-1];
    }
    
    //basic setting
    THIS.$pageSelectFirst.val(firstNumber);
    THIS.$pageSelectLast.val(lastNumber);
    
    THIS.$pageSelectFirst.attr({'max':THIS.$pageSelectLast.val()});
    THIS.$pageSelectLast.attr({'min':THIS.$pageSelectFirst.val()});
    
    THIS.$pageSelectFirst.unbind();
    THIS.$pageSelectFirst.bind('change',function(){
        if(parseInt($(this).val())<0){
            $(this).val(1)
            //return;
        }
        //console.log('!!change',$(this).val(),THIS.$pageSelectLast.val())
        if(parseInt($(this).val())>parseInt(THIS.$pageSelectLast.val())){
            $(this).val(THIS.$pageSelectLast.val())
            //return;
        }
        THIS.$pageSelectLast.attr({'min':$(this).val()});
        $(this).attr({'max':THIS.$pageSelectLast.val()});
        
        THIS.renderData = checkSelect(parseInt(THIS.$pageSelectFirst.val()),parseInt(THIS.$pageSelectLast.val()));
        render(THIS.pageData.display);
    });
    
    THIS.$pageSelectLast.unbind();
    THIS.$pageSelectLast.bind('change',function(){
        if(parseInt($(this).val())>THIS.totalPageNum){
            $(this).val(THIS.totalPageNum)
            //return;
        }
        if(parseInt($(this).val())<parseInt(THIS.$pageSelectFirst.val())){
            $(this).val(THIS.$pageSelectFirst.val())
            //return;
        }
        THIS.$pageSelectFirst.attr({'max':$(this).val()});
        $(this).attr({'min':THIS.$pageSelectFirst.val()});
        
        THIS.renderData = checkSelect(parseInt(THIS.$pageSelectFirst.val()),parseInt(THIS.$pageSelectLast.val()));
        //console.log('!!render')
        render(THIS.pageData.display);
    });
    
}

this.windowHeight =  function(){
    //IE
    if(!window.innerHeight) {
        return $(window).height();
    }
    //w3c
    return window.innerHeight;
}

this.printStart = function(){
    //console.log('print!');
    $('#printDiv').jqprint();
}

this.printCancle = function(){
    parent.popupOpen = false;
    $(document).unbind();
    //console.log($(parent.viewport));
    $(parent.viewport).css({'opacity':1});
    $(parent.toolbarShowBtn).css({'opacity':1});
    $(parent.prevBtn).css({'opacity':1,'visibility':'visible'});
    $(parent.nextBtn).css({'opacity':1,'visibility':'visible'});
    $(parent.toolbarThumbnail).css({'opacity':1});
    $(parent.toolbarControl).css({'opacity':1});
        
    try{
        if($(parent.viewport)[0].style.removeProperty) {
            $(parent.viewport)[0].style.removeProperty('display');
            $(parent.toolbarShowBtn)[0].style.removeProperty('display');
            $(parent.prevBtn)[0].style.removeProperty('display');
            $(parent.nextBtn)[0].style.removeProperty('display');
            $(parent.toolbarThumbnail)[0].style.removeProperty('display');
            $(parent.toolbarControl)[0].style.removeProperty('display');
        }else{
            $(parent.viewport)[0].style.removeAttribute ('display');
            $(parent.toolbarShowBtn)[0].style.removeAttribute ('display');
            $(parent.prevBtn)[0].style.removeAttribute ('display');
            $(parent.nextBtn)[0].style.removeAttribute ('display');
            $(parent.toolbarThumbnail)[0].style.removeAttribute('display');
            $(parent.toolbarControl)[0].style.removeAttribute('display');
        }
        
        
    }catch(e){
        ;
    }
    
    $(parent.printview).remove();
}

/***** contents *******/
this.imageCompCreate = function(data,scale){
    var id = data.attr("id");
    var visible = (data.attr("visible")=="true")? 'visible':'hidden';
    
    var imgUrl = "../../../"+data.attr('source');
    var overImage = null;
    if(data.attr('overImage')) overImage = "../../../"+data.attr('overImage');
    var left = parseInt(scale * data.attr("left"));
    var top = parseInt(scale * data.attr("top"));
    var width = parseInt(scale * data.attr("width"));
    var height = parseInt(scale * data.attr("height"));
    
    var createComp = null;
    
    createComp = $('<img />', {
        id: id,
        'class': 'imageButton',
        src: imgUrl,
        hover: overImage
    });
    
   createComp.css({
        position: 'absolute',
        left:left,
        top:top,
        width:width,
        height:height,
        visibility:visible
    });
   
    return createComp;
}


   
this.textBoxCreate= function(data,scale){
    
    var textval = $.trim(data.text());
    var id = data.attr("id");
    var visible = (data.attr("visible")=="true")? 'visible':'hidden';
    var _alpha = Number(data.attr("alpha"));
    
    var writing = (data.attr("writing")=="true")? true:false;
    var resize = data.attr("resize");
    
    var left = parseInt(scale * data.attr("left"));
    var top = parseInt(scale * data.attr("top"));
    var width = parseInt(data.attr("width"));
    var height = parseInt(data.attr("height"));
    
    var fontSize = data.attr("fontSize");
    var fontName = data.attr("fontName");
    var fontWeight = data.attr("fontWeight");
    var fontStyle = data.attr("fontStyle");
    var underline = data.attr("underline");
    var fontColor = data.attr("color");
    var textAlign = data.attr("textAlign");
    
    var bgColor = data.attr("backgroundColor");
    var bgAlpha = Number(data.attr("backgroundColorAlpha"));
    var boColor = data.attr("borderColor");
    var boWeight = Number(data.attr("borderthickness"));
    
    var textBox = $("<textarea id='"+id+"'></textarea>");
    
    if(!writing){
        $(textBox).attr({'readonly':'readonly'});
        $(textBox).css({'cursor':'pointer'});
    }
    
    $(textBox)
        .css({
            position: 'absolute',
            left:left,
            top:top,
            background:bgColor,
            width:width,
            height:height,
            border:"solid "+boWeight+"px "+boColor,
            overflow:'hidden',
            visibility:visible,
            resize: resize,
            fontWeight:fontWeight,
            color:fontColor,
            opacity:_alpha,
            fontFamily:fontName,
            fontSize:Math.round(parseInt(fontSize)),
            textAlign:textAlign,
            fontStyle:fontStyle,
            textDecoration:underline
        });
        
    if(bgAlpha==0){
        $(textBox).css('background-color','transparent');
    }
      
    $(textBox).text(textval);
    
    scale_xy = "scale("+scale+","+scale+")";
    textBox.css({"transform":scale_xy});
    textBox.css({"-ms-transform":scale_xy});
    textBox.css({"-webkit-transform":scale_xy});
    textBox.css({"-o-transform":scale_xy});
    textBox.css({"-moz-transform":scale_xy});
    textBox.css({"-webkit-transform-origin":'0 0'});
    textBox.css({"-ms-transform-origin":'0 0'});

    return textBox;
}

this.linkBoxCreate= function(data,scale){
    var id = data.attr("id");
    var visible = (data.attr("visible")=="true")? 'visible':'hidden';
    var _alpha = Number(data.attr("alpha"));
    
    var left = parseInt(scale * data.attr("left"));
    var top = parseInt(scale * data.attr("top"));
    var width = parseInt(scale * data.attr("width"));
    var height = parseInt(scale * data.attr("height"));
    
    var bgColor = data.attr("color");
    var overColor = data.attr("hoverColor");
    var boColor = data.attr("borderColor");
    var boWeight = Number(data.attr("borderthickness"));
    
    var linkBox = $("<div/>").attr({
                                 id:id,
                                 'class':"print-link-box"
                             })
                             .css({
                                 left:left,
                                 top:top,
                                 width:width,
                                 height:height,
                                 opacity:_alpha,
                                 display:visible,
                                 position:'absolute'
                                 });
    linkBox.css({
                border:boWeight+"px solid "+boColor,
                background:bgColor
            });  
    return linkBox;
}
